<id>
Streaming 3
</id>

<version>
4.2.2b
</version>

<mod info>
This mod will allow users to stream Real, windows, quicktime and now google video directly into their posts. 
Package manager friendly and is manageable via SMF admin CP.
Based on Hans_de_Echte's (www.het-catshuys.nl) streaming mod. 
</mod info>

<author>
1948pal
http://www.allaboutpalestine.com
</author>

<edit file>
$themedir/languages/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
/* Stream */
$txt['stream'] = 'Add Windows media sound or movies to your posts!';
$txt['real'] = 'Add Real media sound or movies to your posts!';
$txt['quick'] = 'Add QuickTime media sound or movies to your posts!';
$txt['gv'] = 'Add Google video to your posts!';
$txt['yt'] = 'Add YouTube stream to your posts!';
$txt['enableEmbeddedStream'] = 'Embed stream into posts';
$txt['enableEmbeddedReal'] = 'Embed real into posts';
$txt['enableEmbeddedQuick'] = 'Embed QuickTime into posts';
$txt['enableGoogleVideo'] = 'Embed Google video into posts';
$txt['enableYouTube'] = 'Embed YouTube stream into posts';
</add before>

<edit file>
$themedir/languages/Help.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$helptxt['enableEmbeddedStream'] = 'This option will allow your users to use Windows Media Video and Sound directly inside their posts!';
$helptxt['enableEmbeddedReal'] = 'This option will allow your users to use Real Media Video and Sound directly inside their posts!';
$helptxt['enableEmbeddedQuick'] = 'This option will allow your users to use QuickTime Media Video and Sound directly inside their posts!';
$helptxt['enableGoogleVideo'] = 'This option will allow your users to use Google Video directly inside their posts!';
$helptxt['enableYouTube'] = 'This option will allow your users to embed YouTube directly inside their posts!';
</add before>

<edit file>
$themedir/Post.template.php
</edit file>

<search for>
$context['bbc_tags'][] = array(
			'flash' => array('code' => 'flash', 'before' => '[flash=200,200]', 'after' => '[/flash]', 'description' => $txt[433]),
</search for>

<add after>
			'stream' => array('code' => 'stream', 'before' => '[stream=475,325]', 'after' => '[/stream]', 'description' => $txt['stream']),
			'real' => array('code' => 'real', 'before' => '[real=475,325]', 'after' => '[/real]', 'description' => $txt['real']),
			'quick' => array('code' => 'quick', 'before' => '[quick=475,325]', 'after' => '[/quick]', 'description' => $txt['quick']),
			'gv' => array('code' => 'gv', 'before' => '[gv=475,325]', 'after' => '[/gv]', 'description' => $txt['gv']),
			'yt' => array('code' => 'yt', 'before' => '[yt=425,350]', 'after' => '[/yt]', 'description' => $txt['yt']),

</add after>

<edit file>
$sourcedir/Post.php
</edit file>

<search for>
		if ($func['htmltrim'](strip_tags(parse_bbc($_POST['message'], false), '<img>')) === '')
			$post_errors[] = 'no_message';
</search for>

<replace>
		if ($func['htmltrim'](strip_tags(parse_bbc($_POST['message'], false), '<img>')) && (strip_tags(parse_bbc($_POST['message'], false), '<yt>')) === '')
			$post_errors[] = 'no_message'; 
</replace>

<edit file>
$sourcedir/Subs-Post.php
</edit file>

<search for>
		array(
			'tag' => 'flash',
			'protocols' => array('http', 'https'),
			'embeddedUrl' => false,
			'hasEqualSign' => false,
			'hasExtra' => true,
		),
	);
</search for>

<add after>
		// [stream]http://...[/stream]
		array(
			'tag' => 'stream', 
			'protocols' => array('http', 'mms'),
			'embeddedUrl' => false, 
			'hasEqualSign' => false, 
			'hasExtra' => true,
		);
            // [real]http://...[/real]
		array(
			'tag' => 'real',
			'protocols' => array('http', 'rtsp'),
			'embeddedUrl' => false, 
			'hasEqualSign' => false, 
			'hasExtra' => true,
		);
            // [quick]http://...[/quick]
		array(
			'tag' => 'quick', 
			'protocol' => 'http', 
			'embeddedUrl' => false, 
			'hasEqualSign' => false, 
			'hasExtra' => true,
		);
		array(
			'tag' => 'gv', 
			'protocol' => 'http', 
			'embeddedUrl' => false, 
			'hasEqualSign' => false, 
			'hasExtra' => true,
		);	
		array(
			'tag' => 'yt', 
			'protocol' => 'http', 
			'embeddedUrl' => false, 
			'hasEqualSign' => false, 
			'hasExtra' => true,
		);	
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
		/* The following bbc are formatted as an array, with keys as follows:
</search for>

<add before>
		if (empty($modSettings['enableEmbeddedStream']))
		$disabled['stream'] = true;

		if (empty($modSettings['enableEmbeddedReal']))
		$disabled['real'] = true;

		if (empty($modSettings['enableEmbeddedQuick']))
		$disabled['quick'] = true;
		
		if (empty($modSettings['enableGoogleVideo']))
		$disabled['gv'] = true;
		if (empty($modSettings['enableYouTube']))
		$disabled['yt'] = true;

</add before>

<search for>
		'tag' => 'green',
</search for>

<add before>
			'tag' => 'stream',
			'type' => 'unparsed_commas_content',
			'test' => '.+?,.+?]',
			'content' => ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<OBJECT id="mediaPlayer" width="$2" height="$3" classid="CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95" codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701" standby="Loading Microsoft Windows Media Player components..." type="application/x-oleobject" /><param name="fileName" value="$1" /><param name="animationatStart" value="true" /><param name="transparentatStart" value="true" /><param name="autoStart" value="false" /><param name="showControls" value="true" /><param name="loop" value="false" /><param name="showstatusbar" value="true" /></Object>' : '<OBJECT><EMBED type="application/x-mplayer2" pluginspage="http://microsoft.com/windows/mediaplayer/en/download/" id="mediaPlayer" name="mediaPlayer" showcontrols="1" showdisplay="0" showstatusbar="1" width="$2" height="$3" src="$1" autostart="0" /></EMBED></OBJECT>'
		),  
		'validate' => create_function('&$tag, &$data, $disabled', '
					if (isset($disabled[\'url\']))
						$tag[\'content\'] = \'$1\';'),
			'disabled_content' => '<a href="$1" target="_blank">$1</a>',
			),
		array(
			'tag' => 'real',
			'type' => 'unparsed_commas_content',
			'test' => '.+?,.+?]',
			'content' => ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<OBJECT ID=RVOCX width="$2" CLASSID="clsid:CFCDAA03-8BE4-11CF-B84B-0020AFBBCCFA" HEIGHT="$3" /><PARAM NAME="SRC" VALUE="$1" /><PARAM NAME="CONTROLS" VALUE="ImageWindow,ControlPanel" /><PARAM NAME="AUTOSTART" VALUE="FALSE" /></OBJECT><br />' : '<OBJECT ID=RVOCX CLASSID="clsid:CFCDAA03-8BE4-11CF-B84B-0020AFBBCCFA" WIDTH="$2" HEIGHT="100" /><EMBED height="$3" width="$2" controls="ImageWindow,ControlPanel" src="$1" type="audio/x-pn-realaudio-plugin" ImageStatus="true" autostart="false" /></OBJECT>'
		),
		'validate' => create_function('&$tag, &$data, $disabled', '
					if (isset($disabled[\'url\']))
						$tag[\'content\'] = \'$1\';'),
			'disabled_content' => '<a href="$1" target="_blank">$1</a>',
			),
		array(
			'tag' => 'quick',
			'type' => 'unparsed_commas_content',
			'test' => '\d+?,\d+?]',
			'content' => ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<OBJECT classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" width="$2" height="$3" codebase="http://www.apple.com/qtactivex/qtplugin.cab" /><param name="src" value="$1" /><param name="autoplay" value="false" /><param name="controller" value="true" /><param name="loop" value="false" /><EMBED src="$1" width="$2" height="$3" autoplay="false" controller="true" loop="false" pluginspage="http://www.apple.com/quicktime/download/" /></EMBED></OBJECT>' : '<embed src="$1" type="video/quicktime" width="$2" height="$3" autoplay="false" controller="true" pluginspage="http://www.apple.com/quicktime/download/" />'
		),
			'validate' => create_function('&$tag, &$data, $disabled', '
					if (isset($disabled[\'url\']))
						$tag[\'content\'] = \'$1\';'),
			'disabled_content' => '<a href="$1" target="_blank">$1</a>',
		),
array(
			'tag' => 'gv',
			'type' => 'unparsed_commas_content',
			'test' => '\d+?,\d+?]',
			'content' => ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<object width="$2" height="$3" type="application/x-shockwave-flash" data="http://video.google.com/googleplayer.swf">
			<param name="allowScriptAccess" value="sameDomain" />
			<param name="movie" value="http://video.google.com/googleplayer.swf?docId=$1" />
			<param name="quality" value="best" />
			<param name="bgcolor" value="#ffffff" />
			<param name="scale" value="noScale" />
			<param name="wmode" value="window" />
			<param name="salign" value="TL" />
			<param name="FlashVars" value="playerMode=embedded" /></object>' : '<embed width="$2" height="$3" id="VideoPlayback" type="application/x-shockwave-flash" src="http://video.google.com/googleplayer.swf?docId=$1" /></embed></object>'
		),
		'validate' => create_function('&$tag, &$data, $disabled', '
					if (isset($disabled[\'url\']))
						$tag[\'content\'] = \'$1\';'),
			'disabled_content' => '<a href="$1" target="_blank">$1</a>',
		),
array(
			'tag' => 'yt',
			'type' => 'unparsed_commas_content',
			'test' => '.+?,.+?]',
			'content' => ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<object width="$2" height="$3"><param name="movie" value="http://www.youtube.com/v/$1"></param><embed src="http://www.youtube.com/v/$1" type="application/x-shockwave-flash" width="$2" height="$3"></embed></object>' : '<embed width="$2" height="$3" type="application/x-shockwave-flash" src="http://www.youtube.com/v/$1" /></embed>'
		),
		'validate' => create_function('&$tag, &$data, $disabled', '
					if (isset($disabled[\'url\']))
						$tag[\'content\'] = \'$1\';'),
			'disabled_content' => '<a href="$1" target="_blank">$1</a>',
		),		
		array(
</add before>

<search for>
		// !!! Change maybe?
</search for>

<add before>
		$disabled['stream'] = true;
		$disabled['real'] = true;
		$disabled['quick'] = true;
		$disabled['gv'] = true;
		$disabled['yt'] = true;

</add before>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
		'',
			// Who's online.
			array('check', 'who_enabled'),
</search for>

<add after>
		'',
            // The Streaming Mod Options.
        array('check', 'enableEmbeddedStream'),
		array('check', 'enableEmbeddedReal'),
		array('check', 'enableEmbeddedQuick'),
		array('check', 'enableGoogleVideo'),
		array('check', 'enableYouTube'),
</add after>

<edit file>
$sourcedir/ManagePosts.php
</edit file>

<search for>
			'enableEmbeddedFlash' => empty($_POST['enableEmbeddedFlash']) ? '0' : '1',
</search for>

<add after>
			'enableEmbeddedStream' => empty($_POST['enableEmbeddedStream']) ? '0' : '1',
			'enableEmbeddedReal' => empty($_POST['enableEmbeddedReal']) ? '0' : '1',
			'enableEmbeddedQuick' => empty($_POST['enableEmbeddedQuick']) ? '0' : '1',
			'enableGoogleVideo' => empty($_POST['enableGoogleVideo']) ? '0' : '1',
			'enableYouTube' => empty($_POST['enableyouTube']) ? '0' : '1',
</add after>